public class Triangolo
extends Poligono
{
	boolean isoscele = false;

	public Triangolo()
	{
		super(3);
		System.out.println("Costruttore Triangolo");
	}

	/**
	* Controlla se e' possibile avere un triangolo con i lati delle lunghezze date.
	* Ritorna true se e' possibile, false se non lo e'.
	*/
	public static boolean isPossible(double l1, double l2, double l3)
	{
		if(l1 + l2 <= l3)
		{
			return false;
		}
		if(l2 + l3 <= l1)
		{
			return false;
		}
		if(l1 + l3 <= l2)
		{
			return false;
		}
		return true;
	}

	public Lato setLato(int pos, double lung)
	{
		return setLato(pos, new Lato(lung));
	}

	public Lato setLato(int pos, Lato ilLato)
	{
		switch(pos)
		{
			case 0:
				/* esempio di uso short circuit rule
				if(
					(lati[1] != null && lati[2] != null)
						&&
					( (lati[1].getLunghezza() + lati[2].getLunghezza) <= ilLato.getLunghezza())
				)
				{
					throw new RuntimeException();
				}
				*/


				if(lati[1] != null && lati[2] != null)
				{
					if( (lati[1].getLunghezza() + lati[2].getLunghezza()) <= ilLato.getLunghezza())
					{
						throw new RuntimeException();
					}
				}
				break;
			case 1:
				if(lati[0] != null && lati[2] != null)
				{
					if( (lati[0].getLunghezza() + lati[2].getLunghezza()) <= ilLato.getLunghezza())
					{
						throw new RuntimeException();
					}
				}
				break;
			case 2:
				if(lati[0] != null && lati[1] != null)
				{
					if( (lati[0].getLunghezza() + lati[1].getLunghezza()) <= ilLato.getLunghezza())
					{
						throw new RuntimeException();
					}
				}
				break;
			default:
				//siccome il controllo sulla consistenza di pos lo fa il metodo della classe madre, non faccio nulla
				break;
		}
		return super.setLato(pos, ilLato);
	}

	public double area()
	{
		return 0.0;
	}
}
