package it.unipd.stat.se2.coda;

import java.util.NoSuchElementException;

public class GQueue<E>
//extends .....
implements GenericQueue<E>
//implements Queue, GenericQueue<E>
{
	static final int defaultSize = 10;

	protected int maxNumElem;
	int numElem = 0;
	E[] storage;
	/**
	* head contiene l'indice del prossimo elemento da togliere.
	* tail contiene l'indice del prossimo elemento dove inserire. 
	*/
	int head, tail;

	public GQueue(int max)
	{
		maxNumElem = max;
		storage = (E[])new Object[max];
		head = tail = 0;
	}

	public GQueue()
	{
		this(defaultSize);
	}

	public boolean add(E o)
	{
		if(isFull())
		{
			throw new IllegalStateException("Coda piena");
		}
		storage[tail] = o;
		numElem++;
		tail = (tail+1)%maxNumElem;
		return true;
	}

	public boolean offer(E o)
	{
		throw new UnsupportedOperationException("Offer mi sta antipatico");
	}
	/*
	public boolean offer(Object o)
	{
		if(isFull())
		{
			return false;
		}
		return add(o);
	}
	*/

	public E peek()
	{
		if(isEmpty())
		{
			return null;
		}
		return storage[head];
	}

	public E element()
	{
		if(isEmpty())
		{
			throw new NoSuchElementException("Coda vuota");
		}
		//piu' performante
		//return storage[head];
		//piu' manutenibile
		return peek();
	}

	public E remove()
	{
		/*
		if(isEmpty())
		{
			throw new NoSuchElementException("Coda vuota");
		}
		Object retval = storage[head];
		*/
		E retval = element();
		head = (head+1)%maxNumElem;
		numElem--;
		return retval;
	}

	public E poll()
	{
		if(isEmpty())
		{
			return null;
		}
		return remove();
	}

	public int size()
	{
		return numElem;
	}

	public boolean isEmpty()
	{
		return (size() == 0);
	}

	public boolean isFull()
	{
		return (size() == maxNumElem);
	}
}
