package it.unipd.stat.se2.coda;

public class GenericDynamicQueue<E>
implements GenericQueue<E>
{
	int numElem;
	NodoDoppio<E> head, tail;

	public GenericDynamicQueue()
	{
		numElem = 0;
		head = tail = null;
	}

	public boolean add(E o)
	{
		NodoDoppio<E> tmp = new NodoDoppio<E>(o);
		if(isEmpty())
		{
			head = tail = tmp;
		}
		else
		{
			tail.next = tmp;
			tmp.prev = tail;
			tail = tmp;//tail = tail.next;
		}
		numElem++;
		return true;
	}

	public boolean offer(E o)
	{
		return add(o);
	}

	public E peek()
	{
		if(isEmpty())
		{
			return null;
		}
		else
		{
			return head.contenuto;
		}
	}

	public E element()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		return head.contenuto;
	}

	public E remove()
	{
		if(isEmpty())
		{
			throw new java.util.NoSuchElementException("Coda vuota");
		}
		E retval = head.contenuto;
		numElem--;
		if(numElem==0)
		{
			head = tail = null;
		}
		else
		{
			head = head.next;
			head.prev.next = null;
			head.prev = null;
		}
		return retval;
	}

	public E poll()
	{
		if(isEmpty())
		{
			return null;
		}
		return remove();
	}

	public int size()
	{
		return numElem;
	}

	public boolean isEmpty()
	{
		return size() == 0;
	}

	public boolean isFull()
	{
		return false;
	}

	class NodoDoppio<E>
	{
		E contenuto;
		NodoDoppio<E> next, prev;

		NodoDoppio(E cont)
		{
			contenuto = cont;
			next = prev = null;
		}
	}
}
